/*******************************************************************************
 * FoxUIEmoteListWidget generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxUIEmoteListWidget extends FoxUIBaseUnlockListWidget within GFxMoviePlayer
    native(UI);

const MaxSelectedEmotes = 8;

struct native EmoteListEntry extends BaseUnlockEntry
{
    var init string sLength;
    var init string sRemoveTooltip;
    var init string sPreviewTooltip;
    var init string sPreviewFunction;
    var bool bIsSelected;
    var FoxDataProvider_Emote Emote;
};

struct native EmoteRadialEntry
{
    var init string sIcon;
    var init string sName;
    var int UnlockID;

    structdefaultproperties
    {
        sIcon=""
        sName=""
        UnlockID=0
    }
};

var const localized string SecondsLabel;
var transient FoxCustomPlayerActor PreviewActor;
var private transient array<EmoteListEntry> EmoteList;
var private transient array<EmoteRadialEntry> EmoteRadialList;
var private transient array<int> SelectedEmoteUnlocks;
var private transient FoxDataStore_Unlockables UnlockablesDataStore;
var private transient int SelectedAvatarIndex;
var private transient bool bShowRadial;
var private FoxDataProvider_Emote CurrentEmote;

function Initialize(FoxPC PlayerController, optional FoxTypes.EFoxUnlockType ContainedUnlockType)
{
    ContainedUnlockType = 0;
    SelectedEmoteUnlocks.Length = 0;
    super.Initialize(PlayerController, ContainedUnlockType);
    UnlockablesDataStore = FoxDataStore_Unlockables(class'UIInteraction'.static.GetDataStoreClient().FindDataStore(class'FoxDataStore_Unlockables'.default.Tag));
    SetString("armoryListLabel", HeaderLabel);
    //return;    
}

function SetListFromUnlocks(optional array<int> Unlocks)
{
    EmoteList.Length = 0;
    super.SetListFromUnlocks(Unlocks);
    EmoteList.Sort(SortByName);
    as_updateDataProvider(EmoteList);
    //return;    
}

function SetSelectedFromUnlocks(optional array<int> SelectedUnlocks, optional int AvatarIndex)
{
    local int I, EmoteIndex;
    local bool bListSelectable;

    AvatarIndex = -1;
    I = 0;
    J0x15:
    // End:0x64 [Loop If]
    if(I < EmoteList.Length)
    {
        EmoteList[I].bIsSelected = false;
        ++ I;
        // [Loop Continue]
        goto J0x15;
    }
    SelectedEmoteUnlocks.Length = 0;
    bListSelectable = true;
    SelectedAvatarIndex = AvatarIndex;
    I = 0;
    J0x9A:
    // End:0x1C9 [Loop If]
    if(I < SelectedUnlocks.Length)
    {
        EmoteIndex = GetIndexFromUnlock(SelectedUnlocks[I]);
        // End:0x1BB
        if(((EmoteIndex != -1) && EmoteList[EmoteIndex].PurchaseState == 4) || EmoteList[EmoteIndex].PurchaseState == 3)
        {
            EmoteList[EmoteIndex].bIsSelected = true;
            SelectedEmoteUnlocks.AddItem(SelectedUnlocks[I]);
            // End:0x1BB
            if(SelectedEmoteUnlocks.Length >= 8)
            {
                bListSelectable = false;
                // [Explicit Break]
                goto J0x1C9;
            }
        }
        ++ I;
        J0x1C9:
        // [Loop Continue]
        goto J0x9A;
    }
    as_updateDataProvider(EmoteList);
    ToggleListSelection(bListSelectable);
    // End:0x22E
    if(bShowRadial)
    {
        SelectedEmoteUnlocks.Sort(SortByUnlockID);
        SetRadialFromUnlocks(SelectedEmoteUnlocks);
    }
    //return;    
}

function SetSelectedListItem(int Index)
{
    // End:0x1DF
    if((Index >= 0) && Index < EmoteList.Length)
    {
        PendingUnlockID = EmoteList[Index].UnlockID;
        // End:0xA0
        if(EmoteList[Index].PurchaseState > 2)
        {
            SetSelectedListEntry(Index);
        }
        // End:0x1DF
        else
        {
            // End:0x109
            if(CanPurchaseItem(EmoteList[Index].ItemGuid))
            {
                PurchaseItem(EmoteList[Index].ItemGuid, true);
            }
            // End:0x1DF
            else
            {
                // End:0x173
                if(CanActivateItem(EmoteList[Index].ItemGuid))
                {
                    ActivateItem(EmoteList[Index].ItemGuid, true);
                }
                // End:0x1DF
                else
                {
                    // End:0x1AB
                    if(CanRenewItem(EmoteList[Index].ItemGuid))
                    {
                    }
                    // End:0x1DF
                    else
                    {
                        // End:0x1DF
                        if(CanDestroyItem(EmoteList[Index].ItemGuid))
                        {
                        }
                    }
                }
            }
        }
    }
    //return;    
}

function array<int> GetSelectedUnlocks()
{
    return SelectedEmoteUnlocks;
    //return ReturnValue;    
}

function int GetIndexFromUnlock(int UnlockID)
{
    return EmoteList.Find('UnlockID', UnlockID);
    //return ReturnValue;    
}

function int GetUnlockFromIndex(int Index)
{
    // End:0x50
    if((Index >= 0) && Index < EmoteList.Length)
    {
        return EmoteList[Index].UnlockID;
    }
    return super.GetUnlockFromIndex(Index);
    //return ReturnValue;    
}

function ToggleRadialPreview(bool bState)
{
    bShowRadial = bState;
    //return;    
}

function ToggleListSelection(bool bState)
{
    SetBool("bDisableSelect", !bState);
    //return;    
}

protected function SetSelectedListEntry(int Index)
{
    // End:0x189
    if((Index >= 0) && Index < EmoteList.Length)
    {
        EmoteList[Index].bIsSelected = !EmoteList[Index].bIsSelected;
        // End:0xDA
        if(EmoteList[Index].bIsSelected)
        {
            SelectedEmoteUnlocks.AddItem(EmoteList[Index].UnlockID);
        }
        // End:0x10D
        else
        {
            SelectedEmoteUnlocks.RemoveItem(EmoteList[Index].UnlockID);
        }
        as_updateDataProvider(EmoteList);
        ToggleListSelection(SelectedEmoteUnlocks.Length < 8);
        // End:0x176
        if(bShowRadial)
        {
            SelectedEmoteUnlocks.Sort(SortByUnlockID);
            SetRadialFromUnlocks(SelectedEmoteUnlocks);
        }
        super.SetSelectedListEntry(Index);
    }
    //return;    
}

protected function ReloadList()
{
    local array<int> EmoteUnlocks;
    local int I;

    I = 0;
    J0x0B:
    // End:0x8E [Loop If]
    if(I < class'FoxUnlockInfo'.default.TauntUnlocks.Length)
    {
        EmoteUnlocks.AddItem(class'FoxUnlockInfo'.default.TauntUnlocks[I].UnlockID);
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    SetListFromUnlocks(EmoteUnlocks);
    // End:0xDF
    if(bShowRadial)
    {
        SelectedEmoteUnlocks.Sort(SortByUnlockID);
        SetRadialFromUnlocks(SelectedEmoteUnlocks);
    }
    //return;    
}

protected function SetRadialFromUnlocks(optional array<int> Unlocks)
{
    local int I;
    local EmoteRadialEntry EmoteEntry;

    EmoteRadialList.Length = 0;
    I = 0;
    J0x18:
    // End:0xF8 [Loop If]
    if(I < Unlocks.Length)
    {
        // End:0xEA
        if(class'FoxUnlockInfo'.static.GetUnlockInfoFromID(Unlocks[I], EmoteEntry.sName, EmoteEntry.sIcon))
        {
            EmoteEntry.UnlockID = Unlocks[I];
            EmoteRadialList.AddItem(EmoteEntry);
        }
        ++ I;
        // [Loop Continue]
        goto J0x18;
    }
    as_updateRadial(EmoteRadialList);
    //return;    
}

private final event bool GetPreviewAnimName(out name AnimName, FoxTypes.ESpecialMove TauntEnum, optional out float AnimDuration)
{
    local class<FoxSpecialMove_TauntBase> TauntClass;
    local WeaponAnimSet TauntAnim;

    // End:0x211
    if(TauntEnum != 0)
    {
        TauntClass = class<FoxSpecialMove_TauntBase>(class'FoxPawn'.static.GetSpecialMoveClass(TauntEnum));
        // End:0x211
        if((TauntClass != none) && TauntClass.static.GetDefaultAnimsToPlay(TauntAnim, TauntEnum))
        {
            // End:0x112
            if(TauntAnim.TP_Anim.AnimName[0] != 'None')
            {
                AnimName = TauntAnim.TP_Anim.AnimName[0];
            }
            // End:0x193
            else
            {
                // End:0x191
                if(TauntAnim.TP_Anim.AnimName[2] != 'None')
                {
                    AnimName = TauntAnim.TP_Anim.AnimName[2];
                }
                // End:0x193
                else
                {
                    return false;
                }
            }
            // End:0x20F
            if((PreviewActor != none) && PreviewActor.SkeletalMeshComponent != none)
            {
                AnimDuration = PreviewActor.SkeletalMeshComponent.GetAnimLength(AnimName);
            }
            return true;
        }
    }
    return false;
    //return ReturnValue;    
}

private final function int SortByName(const EmoteListEntry InA, const EmoteListEntry InB)
{
    return ((InA.sName <= InB.sName) ? 0 : -1);
    //return ReturnValue;    
}

private final function ei_selectEmote(int EmoteIndex)
{
    SetSelectedListItem(EmoteIndex);
    //return;    
}

private final function ei_previewEmote(int Index)
{
    // End:0xCC
    if(((PreviewActor != none) && Index >= 0) && Index < EmoteList.Length)
    {
        CurrentEmote = EmoteList[Index].Emote;
        PreviewActor.StartFullBodyAnimation(EmoteList[Index].Emote.ThirdPersonAnimName, 0.250, false);
    }
    //return;    
}

private final function as_updateRadial(const array<EmoteRadialEntry> DataProvider)
{
    ActionScriptVoid("updateRadial");
    //return;    
}

private final function as_updateDataProvider(const array<EmoteListEntry> DataProvider)
{
    ActionScriptVoid("updateDataProvider");
    //return;    
}

defaultproperties
{
    SecondsLabel="s"
    HeaderLabel="EMOTES"
    PurchaseLocation=EPurchaseLocation.EPLOC_Customization
}